<?php
/*
 *  SADKExtension.php
 * 
 *  An example file to show the working of a function call with sadk.
 */
try 
{
    $nResult = 0;
    
    $strLogCofigFilePath = "./cfcalog.conf";
    $nResult = cfca_initialize($strLogCofigFilePath);
    if (0 != $nResult) {
        throw new Exception("\n cfca_Initialize error:".$nResult."\n");
    }
    echo "cfca_initialize:nResult:".$nResult."\n\n";
    
    $strSignAlg = "RSA";
    $strSignSourceData = "TestData";
    $strPfxFilePath = "../TestData/RSA/user.pfx";
    $strPfxPassword = "cfca1234";
    $strHashAlg = "SHA-1";
        
    // MSG-PKCS1-Sign 
    $strMsgPKCS1Signature = "";
    $nResult = cfca_signData_PKCS1($strSignAlg, $strSignSourceData, $strPfxFilePath, $strPfxPassword, $strHashAlg, $strMsgPKCS1Signature);
    if (0 != $nResult) {
        throw new Exception("\n cfca_signData_PKCS1 error:".$nResult."\n");
    }
    echo "cfca_signData_PKCS1-strMsgPKCS1Signature:".$strMsgPKCS1Signature."\n";
    echo "cfca_signData_PKCS1-nResult:".$nResult."\n\n";
    
    $strBase64CertContent = "";
    $nResult = cfca_getPublicCertFromPFX($strSignAlg, $strPfxFilePath, $strPfxPassword, $strBase64CertContent);
    if (0 != $nResult) {
        throw new Exception("\n cfca_getPublicCertFromPFX error:".$nResult."\n");
    }
    echo "cfca_getPublicCertFromPFX-strBase64CertContent:".$strBase64CertContent."\n";
    echo "cfca_getPublicCertFromPFX-nResult:".$nResult."\n\n";
    
    // MSG-PKCS1-Verify
    $nResult = cfca_verifyDataSignature_PKCS1($strSignAlg, $strSignSourceData, $strBase64CertContent, $strHashAlg, $strMsgPKCS1Signature);
    if (0 != $nResult) {
        throw new Exception("\n cfca_verifyDataSignature_PKCS1 error:".$nResult."\n");
    }
    echo "cfca_verifyDataSignature_PKCS1-nResult:".$nResult."\n\n";
    
    // Msg PKCS7-detached sign
    $strMsgPKCS7DetachedSignature = "";
    $nResult = cfca_signData_PKCS7Detached($strSignAlg, $strSignSourceData, $strPfxFilePath, $strPfxPassword, $strHashAlg, $strMsgPKCS7DetachedSignature);
    if (0 != $nResult) {
        throw new Exception("\n cfca_signData_PKCS7Detached error:".$nResult."\n");
    }
    echo "cfca_signData_PKCS7Detached-strMsgPKCS7DetachedSignature:".$strMsgPKCS7DetachedSignature."\n";
    echo "cfca_signData_PKCS7Detached-nResult:".$nResult."\n\n";
    
    // Msg PKCS7-detached Verify
    $strMsgP7DetachedSignCertContent = "";
    $nResult = cfca_verifyDataSignature_PKCS7Detached($strSignAlg, $strSignSourceData, $strMsgPKCS7DetachedSignature, $strMsgP7DetachedSignCertContent);
    if (0 != $nResult) {
        throw new Exception("\n cfca_verifyDataSignature_PKCS7Detached error:".$nResult."\n");
    }
    echo "cfca_verifyDataSignature_PKCS7Detached-strMsgP7DetachedSignCertContent:".$strMsgP7DetachedSignCertContent."\n";
    echo "cfca_verifyDataSignature_PKCS7Detached-nResult:".$nResult."\n\n";
    
    // Msg PKCS7-attached Sign
    $strMsgPKCS7AttachedSignature = "";
    $nResult = cfca_signData_PKCS7Attached($strSignAlg, $strSignSourceData, $strPfxFilePath, $strPfxPassword, $strHashAlg, $strMsgPKCS7AttachedSignature);
    if (0 != $nResult) {
        throw new Exception("\n cfca_signData_PKCS7Attached error:".$nResult."\n");
    }
    echo "cfca_signData_PKCS7Attached-strMsgPKCS7AttachedSignature:".$strMsgPKCS7AttachedSignature."\n";
    echo "cfca_signData_PKCS7Attached-nResult:".$nResult."\n\n";
    
    // PKCS7-attached-Verify
    $strMsgP7AttachedSignCertContent = "";
    $strMsgP7AttachedSource = "";
    $nResult = cfca_verifyDataSignature_PKCS7Attached($strSignAlg, $strMsgPKCS7AttachedSignature, $strMsgP7AttachedSignCertContent, $strMsgP7AttachedSource);
    if (0 != $nResult) {
        throw new Exception("\n cfca_verifyDataSignature_PKCS7Attached error:".$nResult."\n");
    }
    echo "cfca_verifyDataSignature_PKCS7Attached-strMsgP7AttachedSignCertContent:".$strMsgP7AttachedSignCertContent."\n";
    echo "cfca_verifyDataSignature_PKCS7Attached-strMsgP7AttachedSource:".$strMsgP7AttachedSource."\n";
    echo "cfca_verifyDataSignature_PKCS7Attached-nResult:".$nResult."\n\n";
    
    // File-PKCS7-Sign
    $strSourceFilePath = "../TestData/SourceFile.txt";
    $strFileP7DetachedSignature = "";
    $nResult = cfca_signFile_PKCS7Detached($strSignAlg, $strSourceFilePath, $strPfxFilePath, $strPfxPassword, $strHashAlg, $strFileP7DetachedSignature);
    if (0 != $nResult) {
        throw new Exception("\n cfca_signFile_PKCS7Detached error:".$nResult."\n");
    }
    echo "cfca_signFile_PKCS7Detached-strFileP7DetachedSignature:".$strFileP7DetachedSignature."\n";
    echo "cfca_signFile_PKCS7Detached-nResult:".$nResult."\n\n";

    // File-PKCS7-Verify
    $strFileP7DetachedSignCert = "";
    $nResult = cfca_verifyFileSignature_PKCS7Detached($strSignAlg, $strSourceFilePath, $strFileP7DetachedSignature, $strFileP7DetachedSignCert);
    if (0 != $nResult) {
        throw new Exception("\n cfca_verifyFileSignature_PKCS7Detached error:".$nResult."\n");
    }
    echo "cfca_verifyFileSignature_PKCS7Detached-strFileP7DetachedSignCert:".$strFileP7DetachedSignCert."\n";
    echo "cfca_verifyFileSignature_PKCS7Detached-nResult:".$nResult."\n\n";    
        
    // CMS-envelope-Encrypt
    $strPlainData = "TestData";
    $strSymEncAlg = "3DES";
    $strCMSEnvelope = "";
    $nResult = cfca_encryptDataToCMSEnvelope($strSignAlg, $strPlainData, $strBase64CertContent, $strSymEncAlg, $strCMSEnvelope);
    if (0 != $nResult) {
        throw new Exception("\n cfca_encryptDataToCMSEnvelope error:".$nResult."\n");
    }
    echo "cfca_encryptDataToCMSEnvelope-strCMSEnvelope:".$strCMSEnvelope."\n";
    echo "cfca_encryptDataToCMSEnvelope-nResult:".$nResult."\n\n";
    
    // CMS-envelope-Decrypt
    $strDecryptData = "";
    $nResult = cfca_decryptDataFromCMSEnvelope($strSignAlg, $strCMSEnvelope, $strPfxFilePath, $strPfxPassword, $strDecryptData);
    if (0 != $nResult) {
        throw new Exception("\n cfca_decryptDataFromCMSEnvelope error:".$nResult."\n");
    }
    echo "cfca_decryptDataFromCMSEnvelope-strDecryptData:".$strDecryptData."\n";
    echo "cfca_decryptDataFromCMSEnvelope-nResult:".$nResult."\n\n";
    
    // File encrypt
    $strFileSymEncAlg = "3DES_CBC";
    $strEncryptFilePath = "../TestData/SourceFile.txt.enc";
    $strSymKey = "";
    $nResult = cfca_symEncryptFile($strFileSymEncAlg, $strSourceFilePath, $strEncryptFilePath, $strSymKey);
    if (0 != $nResult) {
        throw new Exception("\n cfca_symEncryptFile error:".$nResult."\n");
    }
    echo "cfca_symEncryptFile-strSymKey:".$strSymKey."\n";
    echo "cfca_symEncryptFile-nResult:".$nResult."\n\n";
    
    $strDecryptFilePath = "../TestData/SourceFile.txt.enc.txt";
    $nResult = cfca_symDecryptFile($strFileSymEncAlg, $strEncryptFilePath, $strSymKey, $strDecryptFilePath);
    if (0 != $nResult) {
        throw new Exception("\n cfca_symDecryptFile error:".$nResult."\n");
    }
    echo "cfca_symDecryptFile-strDecryptFilePath:".$strDecryptFilePath."\n";
    echo "cfca_symDecryptFile-nResult:".$nResult."\n\n";

    // Cert manipulate
    $nCertVerifyFlag = 7;
    $strTrustedCACertFilePath = "../TestData/RSA/CFCA_TEST_OCA1.cer|../TestData/RSA/CFCA_TEST_CS_CA.cer";
    $strCRLFilePath = "../TestData/RSA/crl6974-not.crl";
    $nResult = cfca_verifyCertificate($strBase64CertContent, $nCertVerifyFlag, $strTrustedCACertFilePath, $strCRLFilePath);
    if (0 != $nResult) {
        throw new Exception("\n cfca_verifyCertificate error:".$nResult."\n");
    }
    echo "cfca_verifyCertificate-nResult:".$nResult."\n\n";
    
    $strInfoType = "CertType";
    $strCertType = "";
    $strSubjectDN = "";
    $strSubjectCN = "";
    $strIssuerDN = "";
    $strSerialNumber = "";
    $strValidFrom = "";
    $strValidTo = "";
    $nResult = cfca_getCertificateInfo($strBase64CertContent, $strInfoType, $strCertType);
    if (0 != $nResult) {
        throw new Exception("\n cfca_getCertificateInfo error:".$nResult."\n");
    }
    echo "cfca_getCertificateInfo-strCertType:".$strCertType."\n";
    echo "cfca_getCertificateInfo-nResult:".$nResult."\n\n";
    
    $nResult = cfca_getCertificateInfo($strBase64CertContent, "SubjectDN", $strSubjectDN);
    if (0 != $nResult) {
        throw new Exception("\n cfca_getCertificateInfo error:".$nResult."\n");
    }
    echo "cfca_getCertificateInfo-strSubjectDN:".$strSubjectDN."\n";
    $nResult = cfca_getCertificateInfo($strBase64CertContent, "SubjectCN", $strSubjectCN);
    if (0 != $nResult) {
        throw new Exception("\n cfca_getCertificateInfo error:".$nResult."\n");
    }
    echo "cfca_getCertificateInfo-strSubjectCN:".$strSubjectCN."\n";
    $nResult = cfca_getCertificateInfo($strBase64CertContent, "IssuerDN", $strIssuerDN);
    if (0 != $nResult) {
        throw new Exception("\n cfca_getCertificateInfo error:".$nResult."\n");
    }
    echo "cfca_getCertificateInfo-strIssuerDN:".$strIssuerDN."\n";
    $nResult = cfca_getCertificateInfo($strBase64CertContent, "SerialNumber", $strSerialNumber);
    if (0 != $nResult) {
        throw new Exception("\n cfca_getCertificateInfo error:".$nResult."\n");
    }
    echo "cfca_getCertificateInfo-strSerialNumber:".$strSerialNumber."\n";
    $nResult = cfca_getCertificateInfo($strBase64CertContent, "ValidFrom", $strValidFrom);
    if (0 != $nResult) {
        throw new Exception("\n cfca_getCertificateInfo error:".$nResult."\n");
    }
    echo "cfca_getCertificateInfo-strValidFrom:".$strValidFrom."\n";
    $nResult = cfca_getCertificateInfo($strBase64CertContent, "ValidTo", $strValidTo);
    if (0 != $nResult) {
        throw new Exception("\n cfca_getCertificateInfo error:".$nResult."\n");
    }
    echo "cfca_getCertificateInfo-strValidTo:".$strValidTo."\n";
    
    // Calculate hash
    $strDataHashAlg = "MD5";
    $strHexDataHash = "";
    $nResult = cfca_calculateDataHash($strSignSourceData, $strDataHashAlg, $strHexDataHash);
    if (0 != $nResult) {
        throw new Exception("\n cfca_calculateDataHash error:".$nResult."\n");
    }
    echo "cfca_calculateDataHash-strHexDataHash:".$strHexDataHash."\n";
    echo "cfca_calculateDataHash-nResult:".$nResult."\n\n";
    
    $strHexFileHash = "";
    $nResult = cfca_calculateFileHash($strSourceFilePath, $strDataHashAlg, $strHexFileHash);
    if (0 != $nResult) {
        throw new Exception("\n cfca_calculateFileHash error:".$nResult."\n");
    }
    echo "cfca_calculateFileHash-strHexFileHash:".$strHexFileHash."\n";
    echo "cfca_calculateFileHash-nResult:".$nResult."\n\n";
    
    $nResult = cfca_uninitialize();
    if (0 != $nResult) {
        throw new Exception("\n cfca_uninitialize error:".$nResult."\n");
    }
    echo "cfca_uninitialize-nResult:".$nResult."\n";
}
catch(Exception $e)
{
    echo "Message:".$e->getMessage();
	cfca_uninitialize();
}
 
?> 
