
<?php
/*
 *  SADKExtension.php
 * 
 *  An example file to show the working of a function call with sadk.
 */
try 
{
    $nResult = 0;
    
    $strLogCofigFilePath = "./cfcalog.conf";
    $nResult = cfca_initialize($strLogCofigFilePath);
    if (0 != $nResult) {
        throw new Exception("\n cfca_Initialize error:".$nResult."\n");
    }
    echo "cfca_initialize:nResult:".$nResult."\n\n";
    
    $strSignAlg = "RSA";
    $strSignSourceData = "TestData";
    $strPfxFilePath = "../TestData/RSA/AS0381.pfx";
    $strPfxPassword = "888888";
    $strHashAlg = "SHA-256";
        
   
    // Msg PKCS7-attached Sign
    $strMsgPKCS7AttachedSignature = "";
    $nResult = cfca_signData_PKCS7Attached($strSignAlg, $strSignSourceData, $strPfxFilePath, $strPfxPassword, $strHashAlg, $strMsgPKCS7AttachedSignature);
    if (0 != $nResult) {
        throw new Exception("\n cfca_signData_PKCS7Attached error:".$nResult."\n");
    }
    echo "cfca_signData_PKCS7Attached-strMsgPKCS7AttachedSignature:".$strMsgPKCS7AttachedSignature."\n";
    echo "cfca_signData_PKCS7Attached-nResult:".$nResult."\n\n";
    
    // PKCS7-attached-Verify
    $strMsgP7AttachedSignCertContent = "";
    $strMsgP7AttachedSource = "";
    $nResult = cfca_verifyDataSignature_PKCS7Attached($strSignAlg, $strMsgPKCS7AttachedSignature, $strMsgP7AttachedSignCertContent, $strMsgP7AttachedSource);
    if (0 != $nResult) {
        throw new Exception("\n cfca_verifyDataSignature_PKCS7Attached error:".$nResult."\n");
    }
    echo "cfca_verifyDataSignature_PKCS7Attached-strMsgP7AttachedSignCertContent:".$strMsgP7AttachedSignCertContent."\n";
    echo "cfca_verifyDataSignature_PKCS7Attached-strMsgP7AttachedSource:".$strMsgP7AttachedSource."\n";
    echo "cfca_verifyDataSignature_PKCS7Attached-nResult:".$nResult."\n\n";


    // Cert manipulate
    $nCertVerifyFlag = 4;
    $strTrustedCACertFilePath = "../TestData/RSA/CFCA_ACS_TEST_OCA31.cer|../TestData/RSA/CFCA_ACS_TEST_CA.cer";
    $strCRLFilePath = "../TestData/RSA/crl6974.crl";
    #$strCRLFilePath = null;
    #$nResult = cfca_verifyCertificate($strMsgP7AttachedSignCertContent, $nCertVerifyFlag, $strTrustedCACertFilePath,$strCRLFilePath);
    $nResult = cfca_verifyCertificate($strMsgP7AttachedSignCertContent, $nCertVerifyFlag, $strTrustedCACertFilePath,"");
    if (0 != $nResult) {
        throw new Exception("\n cfca_verifyCertificate error:".$nResult."\n");
    }
    echo "cfca_verifyCertificate-nResult:".$nResult."\n\n";    

    $strInfoType = "CertType";
    $strCertType = "";
    $strSubjectDN = "";
    $strSubjectCN = "";
    $strIssuerDN = "";
    $strSerialNumber = "";
    $strValidFrom = "";
    $strValidTo = "";
    $nResult = cfca_getCertificateInfo($strMsgP7AttachedSignCertContent, $strInfoType, $strCertType);
    if (0 != $nResult) {
        throw new Exception("\n cfca_getCertificateInfo error:".$nResult."\n");
    }
    echo "cfca_getCertificateInfo-strCertType:".$strCertType."\n";
    echo "cfca_getCertificateInfo-nResult:".$nResult."\n\n";
    
    $nResult = cfca_getCertificateInfo($strMsgP7AttachedSignCertContent, "SubjectDN", $strSubjectDN);
    if (0 != $nResult) {
        throw new Exception("\n cfca_getCertificateInfo error:".$nResult."\n");
    }
    echo "cfca_getCertificateInfo-strSubjectDN:".$strSubjectDN."\n";
    $nResult = cfca_getCertificateInfo($strMsgP7AttachedSignCertContent, "SubjectCN", $strSubjectCN);
    if (0 != $nResult) {
        throw new Exception("\n cfca_getCertificateInfo error:".$nResult."\n");
    }
    echo "cfca_getCertificateInfo-strSubjectCN:".$strSubjectCN."\n";
    $nResult = cfca_getCertificateInfo($strMsgP7AttachedSignCertContent, "IssuerDN", $strIssuerDN);
    if (0 != $nResult) {
        throw new Exception("\n cfca_getCertificateInfo error:".$nResult."\n");
    }
    echo "cfca_getCertificateInfo-strIssuerDN:".$strIssuerDN."\n";
    $nResult = cfca_getCertificateInfo($strMsgP7AttachedSignCertContent, "SerialNumber", $strSerialNumber);
    if (0 != $nResult) {
        throw new Exception("\n cfca_getCertificateInfo error:".$nResult."\n");
    }
    echo "cfca_getCertificateInfo-strSerialNumber:".$strSerialNumber."\n";
    $nResult = cfca_getCertificateInfo($strMsgP7AttachedSignCertContent, "ValidFrom", $strValidFrom);
    if (0 != $nResult) {
        throw new Exception("\n cfca_getCertificateInfo error:".$nResult."\n");
    }
    echo "cfca_getCertificateInfo-strValidFrom:".$strValidFrom."\n";
    $nResult = cfca_getCertificateInfo($strMsgP7AttachedSignCertContent, "ValidTo", $strValidTo);
    if (0 != $nResult) {
        throw new Exception("\n cfca_getCertificateInfo error:".$nResult."\n");
    }
    echo "cfca_getCertificateInfo-strValidTo:".$strValidTo."\n";
  
    
    $nResult = cfca_uninitialize();
    if (0 != $nResult) {
        throw new Exception("\n cfca_uninitialize error:".$nResult."\n");
    }
    echo "cfca_uninitialize-nResult:".$nResult."\n";
}
catch(Exception $e)
{
    echo "Message:".$e->getMessage();
    cfca_uninitialize();
}
 
?> 

