<?php
/*
 *  SADKExtension.php
 * 
 *  An example file to show the working of a function call with sadk.
 */
try 
{
    $nWholeRunTimes = 1000000;
    $nCurrentTime = 0;
     
    $nResult = 0;
    
    $strLogCofigFilePath = "./cfcalog.conf";
    $nResult = cfca_initialize($strLogCofigFilePath);
    if (0 != $nResult) {
        throw new Exception("\n cfca_Initialize error:".$nResult."\n");
    }
	
	for($nCurrentTime = 0; $nCurrentTime < $nWholeRunTimes; $nCurrentTime++)
	{
        if($nCurrentTime % 100 == 0)
        {
            echo "Whole time:".$nWholeRunTimes."\t CurrentTime:".$nCurrentTime."\n";
        }
        
        $strSignAlg = "RSA";
        $strSignSourceData = "TestData";
        $strPfxFilePath = "../TestData/RSA/user.pfx";
        $strPfxPassword = "cfca1234";
        $strHashAlg = "SHA-1";
        
        // PKCS1-Sign
        $strMsgPKCS1Signature = "";
        $nResult = cfca_signData_PKCS1($strSignAlg, $strSignSourceData, $strPfxFilePath, $strPfxPassword, $strHashAlg, $strMsgPKCS1Signature);
        if (0 != $nResult) {
            throw new Exception("\n cfca_signData_PKCS1 error:".$nResult."\n");
        }
        
        $strBase64CertContent = "";
        $nResult = cfca_getPublicCertFromPFX($strSignAlg, $strPfxFilePath, $strPfxPassword, $strBase64CertContent);
        if (0 != $nResult) {
            throw new Exception("\n cfca_getPublicCertFromPFX error:".$nResult."\n");
        }
        
        // PKCS1-Verify
        $nResult = cfca_verifyDataSignature_PKCS1($strSignAlg, $strSignSourceData, $strBase64CertContent, $strHashAlg, $strMsgPKCS1Signature);
        if (0 != $nResult) {
            throw new Exception("\n cfca_verifyDataSignature_PKCS1 error:".$nResult."\n");
        }
        
        // Msg PKCS7-detached sign
        $strMsgPKCS7DetachedSignature = "";
        $nResult = cfca_signData_PKCS7Detached($strSignAlg, $strSignSourceData, $strPfxFilePath, $strPfxPassword, $strHashAlg, $strMsgPKCS7DetachedSignature);
        if (0 != $nResult) {
            throw new Exception("\n cfca_signData_PKCS7Detached error:".$nResult."\n");
        }
        
        // Msg PKCS7-detached Verify
        $strMsgP7DetachedSignCertContent = "";
        $nResult = cfca_verifyDataSignature_PKCS7Detached($strSignAlg, $strSignSourceData, $strMsgPKCS7DetachedSignature, $strMsgP7DetachedSignCertContent);
        if (0 != $nResult) {
            throw new Exception("\n cfca_verifyDataSignature_PKCS7Detached error:".$nResult."\n");
        }
        
        // Msg PKCS7-attached Sign
        $strMsgPKCS7AttachedSignature = "";
        $nResult = cfca_signData_PKCS7Attached($strSignAlg, $strSignSourceData, $strPfxFilePath, $strPfxPassword, $strHashAlg, $strMsgPKCS7AttachedSignature);
        if (0 != $nResult) {
            throw new Exception("\n cfca_signData_PKCS7Attached error:".$nResult."\n");
        } 
        
        // PKCS7-attached-Verify
        $strMsgP7AttachedSignCertContent = "";
        $strMsgP7AttachedSource = "";
        $nResult = cfca_verifyDataSignature_PKCS7Attached($strSignAlg, $strMsgPKCS7AttachedSignature, $strMsgP7AttachedSignCertContent, $strMsgP7AttachedSource);
        if (0 != $nResult) {
            throw new Exception("\n cfca_verifyDataSignature_PKCS7Attached error:".$nResult."\n");
        }
       
        // File-PKCS7-Sign
        $strSourceFilePath = "../TestData/SourceFile.txt";
        $strFileP7DetachedSignature = "";
        $nResult = cfca_signFile_PKCS7Detached($strSignAlg, $strSourceFilePath, $strPfxFilePath, $strPfxPassword, $strHashAlg, $strFileP7DetachedSignature);
        if (0 != $nResult) {
            throw new Exception("\n cfca_signFile_PKCS7Detached error:".$nResult."\n");
        }
        
        // File-PKCS7-Verify
        $strFileP7DetachedSignCert = "";
        $nResult = cfca_verifyFileSignature_PKCS7Detached($strSignAlg, $strSourceFilePath, $strFileP7DetachedSignature, $strFileP7DetachedSignCert);
        if (0 != $nResult) {
            throw new Exception("\n cfca_verifyFileSignature_PKCS7Detached error:".$nResult."\n");
        }
        
        // CMS-envelope-Encrypt
        $strPlainData = "TestData";
        $strSymEncAlg = "3DES";
        $strCMSEnvelope = "";
        $nResult = cfca_encryptDataToCMSEnvelope($strSignAlg, $strPlainData, $strBase64CertContent, $strSymEncAlg, $strCMSEnvelope);
        if (0 != $nResult) {
            throw new Exception("\n cfca_encryptDataToCMSEnvelope error:".$nResult."\n");
        }
        
        // CMS-envelope-Decrypt
        $strDecryptData = "";
        $nResult = cfca_decryptDataFromCMSEnvelope($strSignAlg, $strCMSEnvelope, $strPfxFilePath, $strPfxPassword, $strDecryptData);
        if (0 != $nResult) {
            throw new Exception("\n cfca_decryptDataFromCMSEnvelope error:".$nResult."\n");
        }
        
        // File encrypt
        $strFileSymEncAlg = "3DES_CBC";
        $strEncryptFilePath = "../TestData/SourceFile.txt.enc";
        $strSymKey = "";
        $nResult = cfca_symEncryptFile($strFileSymEncAlg, $strSourceFilePath, $strEncryptFilePath, $strSymKey);
        if (0 != $nResult) {
            throw new Exception("\n cfca_symEncryptFile error:".$nResult."\n");
        }
        
        $strDecryptFilePath = "../TestData/SourceFile.txt.enc.txt";
        $nResult = cfca_symDecryptFile($strFileSymEncAlg, $strEncryptFilePath, $strSymKey, $strDecryptFilePath);
        if (0 != $nResult) {
            throw new Exception("\n cfca_symDecryptFile error:".$nResult."\n");
        }
        
        // Cert manipulate
        $nCertVerifyFlag = 7;
        $strTrustedCACertFilePath = "../TestData/RSA/CFCA_TEST_OCA1.cer|../TestData/RSA/CFCA_TEST_CS_CA.cer";
        $strCRLFilePath = "../TestData/RSA/crl6974-not.crl";
        $nResult = cfca_verifyCertificate($strBase64CertContent, $nCertVerifyFlag, $strTrustedCACertFilePath, $strCRLFilePath);
        if (0 != $nResult) {
            throw new Exception("\n cfca_verifyCertificate error:".$nResult."\n");
        }
        
        $strInfoType = "CertType";
        $strCertType = "";
        $strSubjectDN = "";
        $strSubjectCN = "";
        $strIssuerDN = "";
        $strSerialNumber = "";
        $strValidFrom = "";
        $strValidTo = "";
        $nResult = cfca_getCertificateInfo($strBase64CertContent, $strInfoType, $strCertType);
        if (0 != $nResult) {
            throw new Exception("\n cfca_getCertificateInfo error:".$nResult."\n");
        }
        $nResult = cfca_getCertificateInfo($strBase64CertContent, "SubjectDN", $strSubjectDN);
        if (0 != $nResult) {
            throw new Exception("\n cfca_getCertificateInfo error:".$nResult."\n");
        }
        $nResult = cfca_getCertificateInfo($strBase64CertContent, "SubjectCN", $strSubjectCN);
        if (0 != $nResult) {
            throw new Exception("\n cfca_getCertificateInfo error:".$nResult."\n");
        }
        $nResult = cfca_getCertificateInfo($strBase64CertContent, "IssuerDN", $strIssuerDN);
        if (0 != $nResult) {
            throw new Exception("\n cfca_getCertificateInfo error:".$nResult."\n");
        }
        $nResult = cfca_getCertificateInfo($strBase64CertContent, "SerialNumber", $strSerialNumber);
        if (0 != $nResult) {
            throw new Exception("\n cfca_getCertificateInfo error:".$nResult."\n");
        }
        $nResult = cfca_getCertificateInfo($strBase64CertContent, "ValidFrom", $strValidFrom);
        if (0 != $nResult) {
            throw new Exception("\n cfca_getCertificateInfo error:".$nResult."\n");
        }
        $nResult = cfca_getCertificateInfo($strBase64CertContent, "ValidTo", $strValidTo);
        if (0 != $nResult) {
            throw new Exception("\n cfca_getCertificateInfo error:".$nResult."\n");
        }
        
        // Calculate hash
        $strDataHashAlg = "MD5";
        $strHexDataHash = "";
        $nResult = cfca_calculateDataHash($strSignSourceData, $strDataHashAlg, $strHexDataHash);
        if (0 != $nResult) {
            throw new Exception("\n cfca_calculateDataHash error:".$nResult."\n");
        }
        
        $strHexFileHash = "";
        $nResult = cfca_calculateFileHash($strSourceFilePath, $strDataHashAlg, $strHexFileHash);
        if (0 != $nResult) {
            throw new Exception("\n cfca_calculateFileHash error:".$nResult."\n");
        }
    }
	
    $nResult = cfca_uninitialize();
    if (0 != $nResult) {
        throw new Exception("\n cfca_uninitialize error:".$nResult."\n");
    }
    echo "cfca_uninitialize-nResult:".$nResult."\n";
}
catch(Exception $e)
{
    echo "Message:".$e->getMessage();
	cfca_uninitialize();
}
 
